import { Constants } from './constants'
export class Length {
  value
  unit

  constructor(val, uint) {
    this.value = val
    this.unit = uint
  }

  getVal() {
    return this.value
  }  

  getUint() {
    return this.unit
  }
  parseTo(unitNode) {
    let unitLength = this
    if (this.unit === Constants.YARD) {
      if (unitNode === Constants.FOOT) {
        unitLength = new Length(this.multipleValue(3), unitNode)
      } else if (unitNode === Constants.INCH) {
        unitLength = new Length(this.multipleValue(36), unitNode)
      }
    }

    if (this.unit === Constants.INCH) {
      if (unitNode === Constants.YARD) {
        unitLength = new Length(this.divisionValue(36), unitNode)
      } else if (unitNode === Constants.FOOT) {
        unitLength = new Length(this.value / 12, unitNode)
      }
    }

    if (this.unit === Constants.FOOT) {
      if (unitNode === Constants.YARD) {
        unitLength = new Length(this.divisionValue(3), unitNode)
      } else if (unitNode === Constants.INCH) {
        unitLength = new Length(this.multipleValue(12), unitNode)
      }
    }
    
    return unitLength
  }
  as(targetUnit) {
    return new Length(this._valueIn(targetUnit), targetUnit)
  }
  _valueIn(unit) {
    if(this.unit === Constants.YARD) {
      if(unit === Constants.FOOT) {
        // this.multipleValue(3)
        return this.value * 3
      }
      if(unit === Constants.INCH) {
        // this.multipleValue(36)
        return this.value * 36
      }
    }
    if(this.unit === Constants.INCH) {
      if(unit === Constants.YARD) {
        // this.divisionValue(3)
        return this.value / 36
      }
      if(unit ===Constants.FOOT) {
        // this.divisionValue(12)
        return this.value / 12
      }
    }
    if(this.unit === Constants.FOOT) {
      if(unit === Constants.YARD) {
        // this.divisionValue(3)
        return this.value / 3
      }
      if(unit === Constants.INCH) {
        // this.multipleValue(12)
        return this.value * 12
      }
    }
  }

  divisionValue(conversion_Target_Unit_Value) {
    return this.value / conversion_Target_Unit_Value
  }

  multipleValue(conversion_Target_Unit_Value) {
    return this.value * conversion_Target_Unit_Value
  }
}
